
#pragma hdrstop
#include <condefs.h>
#include <iostream.h>
#include <shlobj.h>

//---------------------------------------------------------------------------
#pragma argsused
void error()
{
 int err=GetLastError();
 char* lpMsgBuf;
 FormatMessage(
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    err,
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL
 );
 MessageBox( NULL, lpMsgBuf, "GetLastError", MB_OK|MB_ICONSTOP );
 LocalFree( lpMsgBuf );
 exit(err);
}

void showusage()
{
 cout<<endl;
 cout<<"Usage:"<<endl;
 cout<<"ln [keys] <object> <*.lnk>"<<endl;
 cout<<"Keys:"<<endl;
 cout<<"-a \"<args>\"                   set command line arguments to start <object>"<<endl;
 cout<<"-d \"<description>\"            set <object's> description"<<endl;
 cout<<"-i <icon file>[,<icon index>] set icon to display by Explorer"<<endl;
 cout<<"-p <workdir>                  set default path when <object> runs"<<endl;
 cout<<"-s <showmode>                 set window show mode (see SW_ codes below)"<<endl;
 cout<<"                              SW_SHOWNORMAL=1, SW_SHOWMAXIMIZED=3,"<<endl;
 cout<<"                              SW_SHOWMINNOACTIVE=7"<<endl;
 cout<<"-k <hotkey code>              set hotkey (see below)"<<endl;
 cout<<"                              HotkeyCode=(OredModifiers<<8)+Keycode"<<endl;
 cout<<"                              modifiers: HOTKEYF_SHIFT=1, HOTKEYF_CONTROL=2,"<<endl;
 cout<<"                                         HOTKEYF_ALT=4"<<endl;
 cout<<"                              keycodes: 'A'=65 ... 'Z'=90,"<<endl;
 cout<<"                                        VK_F1=112 ... VK_F10=121"<<endl;
 cout<<"-f \"<folder name>\"            place link into specified shell folder"<<endl;
 cout<<"                              shell folders for any user:"<<endl;
 cout<<"                              Desktop, Favorites (NT), Programs (NT),"<<endl;
 cout<<"                              Start Menu (NT), Startup."<<endl;
 cout<<"                              shell folders for current user only:"<<endl;
 cout<<"                              Favorites, Personal, Programs, Recent, SendTo,"<<endl;
 cout<<"                              Start Menu."<<endl;
 cout<<"-c                            place link into shell folder (key '-f') common"<<endl;
 cout<<"                              for all users"<<endl;
 cout<<endl;
 exit(1);
}

int targc=0;
char* targv[30];

void parsecommand()
{
 char* cmd=GetCommandLine();
 int i;
 int inquot=0;
 int len=strlen(cmd);
 targv[0]=cmd;
 if(cmd[0]!='\"') targc=1;
 for(i=0;i<len&&targc<30;i++)
 {
  switch(cmd[i])
  {
   case '\"':
    if(inquot)
     cmd[i]=0;
    else
     targv[targc++]=&cmd[i+1];
    inquot=!inquot;
   break;
   case ' ':
    if(!inquot)
    {
     cmd[i]=0;
     if(cmd[i+1]!=' '&&cmd[i+1]!='\"'&&cmd[i+1]!=0)
      targv[targc++]=&cmd[i+1];
    }
   break;
   default:
    targv[targc]=&cmd[i];
  }
 }
}


int main()
{
 cout<<"Link Creator v.1.0.1\n(c) Gelin, 2002 (den-gelin.narod.ru)\n\
Allow to program create link (shortcut) to file."<<endl;
 parsecommand();
 if(targc<3) showusage();
 char buf[MAX_PATH+1];
 char wbuf[MAX_PATH*2]; 
 char* tmp;
 char* A=NULL;
 char* D=NULL;
 int K=-1;
 char* I=NULL;
 int Ii=0;
 int S=SW_NORMAL;
 char* P=NULL;
 char* F=NULL;
 bool C=false;
 for(int i=1;i<targc-2;i++)
 {
  if(targv[i][0]=='-'||targv[i][0]=='/')
   switch(targv[i][1])
   {
    case 'a': case 'A':
     i++;
     A=targv[i];
    break;
    case 'd': case 'D':
     i++;
     D=targv[i];
    break;
    case 'k': case 'K':
     i++;
     K=atoi(targv[i]);
    break;
    case 'i': case 'I':
     i++;
     I=targv[i];
     if(tmp=strstr(I,","))
     {
      tmp[0]=0;
      Ii=atoi(tmp+1);
     }
    break;
    case 's': case 'S':
     i++;
     S=atoi(targv[i]);
    break;
    case 'p': case 'P':
     i++;
     P=targv[i];
    break;
    case 'f': case 'F':
     i++;
     F=targv[i];
    break;
    case 'c': case 'C':
     C=true;
    break;
    default:
     showusage();
   }
  else showusage();
 }
 CoInitialize(NULL);
 IShellLink* slink;
 IPersistFile* pfile;
 CoCreateInstance(CLSID_ShellLink, NULL,CLSCTX_INPROC_SERVER, IID_IShellLink, &(void*)slink);
 if(!slink) error();
 GetFullPathName(targv[targc-2],MAX_PATH*2,buf,&tmp);
 slink->SetPath(buf);
 if(P) slink->SetWorkingDirectory(P);
 else
 {
  tmp[0]=0;
  slink->SetWorkingDirectory(buf);
 }
 if(A) slink->SetArguments(A);
 if(D) slink->SetDescription(D);
 if(K>=0) slink->SetHotkey(K);
 if(I) slink->SetIconLocation(I,Ii);
 slink->SetShowCmd(S);
 slink->QueryInterface(IID_IPersistFile,&(void*)pfile);
 if(!pfile) error();
 if(F)
 {
  HKEY regkey;
  if(!C)
  {
   if(RegOpenKeyEx(HKEY_CURRENT_USER,
         "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
         0,
         KEY_QUERY_VALUE,
         &regkey)
         !=ERROR_SUCCESS) error();
  }
  else if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,
         "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
         0,
         KEY_QUERY_VALUE,
         &regkey)
         !=ERROR_SUCCESS) error();
  unsigned long size=MAX_PATH;
  unsigned long type=REG_SZ;
  if(C) strcpy(wbuf,"Common ");
  else strcpy(wbuf,"");
  strcat(wbuf,F);
  if(RegQueryValueEx(regkey,
         wbuf,
         NULL,
         &type,
         buf,
         &size)
         !=ERROR_SUCCESS) error();
  if(RegCloseKey(regkey)!=ERROR_SUCCESS) error();
  strcat(buf,"\\");
 }
 else strcpy(buf,"");
 strcat(buf,targv[targc-1]);
 strcpy(wbuf,buf);
 if(tmp=strrchr(wbuf,'\\'))
 {
  tmp[0]=0;
  int i=0;
  while(!CreateDirectory(wbuf,NULL)&&(tmp=strrchr(wbuf,'\\')))
  {
   tmp[0]=0;
   i++;
  }
  while(i)
  {
   wbuf[strlen(wbuf)]='\\';
   i--;
   CreateDirectory(wbuf,NULL);
  }
 }
 MultiByteToWideChar(CP_ACP, 0, buf, -1, (wchar_t*)wbuf, MAX_PATH);
 if(pfile->Save((wchar_t*)wbuf, TRUE)!=S_OK) error();
 pfile->Release();
 slink->Release();
 CharToOem(targv[targc-1],targv[targc-1]);
 CharToOem(targv[targc-2],targv[targc-2]);
 cout<<targv[targc-1]<<" --> "<<targv[targc-2]<<endl;
 return 0;
}
